//
// DmasAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class DmasAPI {
    /**
     DMA geographical metadata

     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func dmasDmaIdGet(dmaId: Int, completion: @escaping ((_ data: DmaObj?,_ error: Error?) -> Void)) {
        dmasDmaIdGetWithRequestBuilder(dmaId: dmaId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     DMA geographical metadata
     - GET /dmas/{dmaId}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "timezone" : "America/New_York",
  "countryCode" : "US",
  "dmaId" : 529,
  "dmaName" : "Louisville",
  "countryName" : "United States of America",
  "samplePoints" : [ {
    "onpointId" : 10725864,
    "distance" : 1536552,
    "grid" : "NORTH_AMERICA_GRID",
    "latitude" : 38.8552,
    "longitude" : -77.0513
  }, {
    "onpointId" : 10725864,
    "distance" : 1536552,
    "grid" : "NORTH_AMERICA_GRID",
    "latitude" : 38.8552,
    "longitude" : -77.0513
  } ],
  "population" : 1584746
}}]
     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 

     - returns: RequestBuilder<DmaObj> 
     */
    open class func dmasDmaIdGetWithRequestBuilder(dmaId: Int) -> RequestBuilder<DmaObj> {
        var path = "/dmas/{dmaId}"
        let dmaIdPreEscape = "\(dmaId)"
        let dmaIdPostEscape = dmaIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dmaId}", with: dmaIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil

        let url = URLComponents(string: URLString)

        let requestBuilder: RequestBuilder<DmaObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }

}
