//
// OnpointsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class OnpointsAPI {
    /**
     OnPoint™ point geographical metadata

     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func onpointsOnpointIdGet(onpointId: Int, completion: @escaping ((_ data: OnpointObj?,_ error: Error?) -> Void)) {
        onpointsOnpointIdGetWithRequestBuilder(onpointId: onpointId).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     OnPoint™ point geographical metadata
     - GET /onpoints/{onpointId}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "onpointId" : 10725864,
  "timezone" : "America/New_York",
  "countryCode" : "US",
  "grid" : "NORTH_AMERICA_GRID",
  "latitude" : 38.8552,
  "countryName" : "United States of America",
  "subdivName" : "Virginia",
  "subdivCode" : "US-VA",
  "longitude" : -77.0513
}}]
     - parameter onpointId: (path) An OnPoint™ ID. 

     - returns: RequestBuilder<OnpointObj> 
     */
    open class func onpointsOnpointIdGetWithRequestBuilder(onpointId: Int) -> RequestBuilder<OnpointObj> {
        var path = "/onpoints/{onpointId}"
        let onpointIdPreEscape = "\(onpointId)"
        let onpointIdPostEscape = onpointIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{onpointId}", with: onpointIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil

        let url = URLComponents(string: URLString)

        let requestBuilder: RequestBuilder<OnpointObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }

}
