//
// PostcodesAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class PostcodesAPI {
    /**
     Postcode geographical metadata

     - parameter postcode: (path) A postcode string. 
     - parameter countryCode: (path) An uppercase 2-character [ISO 3166-1 Alpha-2 country code](https://developer.weathersourceapis.com/apis/countries-with-postal-code-support/). 
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func postcodesPostcodecountryCodeGet(postcode: String, countryCode: String, completion: @escaping ((_ data: PostcodeObj?,_ error: Error?) -> Void)) {
        postcodesPostcodecountryCodeGetWithRequestBuilder(postcode: postcode, countryCode: countryCode).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Postcode geographical metadata
     - GET /postcodes/{postcode},{countryCode}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "boundingPoints" : [ {
    "onpointId" : 10725864,
    "distance" : 2.6772,
    "grid" : "NORTH_AMERICA_GRID"
  }, {
    "onpointId" : 10725864,
    "distance" : 2.6772,
    "grid" : "NORTH_AMERICA_GRID"
  } ],
  "timezone" : "America/New_York",
  "countryCode" : "US",
  "grid" : "NORTH_AMERICA_GRID",
  "latitude" : 38.8552,
  "postcode" : "22222",
  "countryName" : "United States of America",
  "subdivName" : "Virginia",
  "subdivCode" : "US-VA",
  "longitude" : -77.0513
}}]
     - parameter postcode: (path) A postcode string. 
     - parameter countryCode: (path) An uppercase 2-character [ISO 3166-1 Alpha-2 country code](https://developer.weathersourceapis.com/apis/countries-with-postal-code-support/). 

     - returns: RequestBuilder<PostcodeObj> 
     */
    open class func postcodesPostcodecountryCodeGetWithRequestBuilder(postcode: String, countryCode: String) -> RequestBuilder<PostcodeObj> {
        var path = "/postcodes/{postcode},{countryCode}"
        let postcodePreEscape = "\(postcode)"
        let postcodePostEscape = postcodePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{postcode}", with: postcodePostEscape, options: .literal, range: nil)
        let countryCodePreEscape = "\(countryCode)"
        let countryCodePostEscape = countryCodePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{countryCode}", with: countryCodePostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil

        let url = URLComponents(string: URLString)

        let requestBuilder: RequestBuilder<PostcodeObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }

}
